<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>POIFSReader (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="POIFSReader (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/POIFSReader.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li>Prev&nbsp;Class</li>
        <li><a href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderEvent.html"
               title="class in org.apache.poi.poifs.eventfilesystem"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/eventfilesystem/POIFSReader.html" target="_top">Frames</a>
        </li>
        <li><a href="POIFSReader.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.poifs.eventfilesystem</div>
    <h2 title="Class POIFSReader" class="title">Class POIFSReader</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.poifs.eventfilesystem.POIFSReader</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">POIFSReader</span>
extends java.lang.Object</pre>
                <div class="block">An event-driven reader for POIFS file systems. Users of this class
                    first create an instance of it, then use the registerListener
                    methods to register POIFSReaderListener instances for specific
                    documents. Once all the listeners have been registered, the read()
                    method is called, which results in the listeners being notified as
                    their documents are read.
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#POIFSReader--">POIFSReader</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#main-java.lang.String:A-">main</a></span>(java.lang.String[]&nbsp;args)</code>
                                    <div class="block">read in files</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#read-java.io.File-">read</a></span>(java.io.File&nbsp;poifsFile)</code>
                                    <div class="block">Read from a File and process the documents we get</div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#read-java.io.InputStream-">read</a></span>(java.io.InputStream&nbsp;stream)</code>
                                    <div class="block">Read from an InputStream and process the documents we get</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#read-org.apache.poi.poifs.filesystem.POIFSFileSystem-">read</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;poifs)</code>
                                    <div class="block">Read from a NPOIFSFileSystem and process the documents we get
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#registerListener-org.apache.poi.poifs.eventfilesystem.POIFSReaderListener-">registerListener</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem">POIFSReaderListener</a>&nbsp;listener)</code>
                                    <div class="block">Register a POIFSReaderListener for all documents</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#registerListener-org.apache.poi.poifs.eventfilesystem.POIFSReaderListener-org.apache.poi.poifs.filesystem.POIFSDocumentPath-java.lang.String-">registerListener</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem">POIFSReaderListener</a>&nbsp;listener,
                                    <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSDocumentPath.html"
                                       title="class in org.apache.poi.poifs.filesystem">POIFSDocumentPath</a>&nbsp;path,
                                    java.lang.String&nbsp;name)</code>
                                    <div class="block">Register a POIFSReaderListener for a document in the specified
                                        directory
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#registerListener-org.apache.poi.poifs.eventfilesystem.POIFSReaderListener-java.lang.String-">registerListener</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem">POIFSReaderListener</a>&nbsp;listener,
                                    java.lang.String&nbsp;name)</code>
                                    <div class="block">Register a POIFSReaderListener for a document in the root
                                        directory
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReader.html#setNotifyEmptyDirectories-boolean-">setNotifyEmptyDirectories</a></span>(boolean&nbsp;notifyEmptyDirectories)</code>
                                    <div class="block">Activates the notification of empty directories.</div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="POIFSReader--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>POIFSReader</h4>
                                <pre>public&nbsp;POIFSReader()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="read-java.io.InputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>read</h4>
                                <pre>public&nbsp;void&nbsp;read(java.io.InputStream&nbsp;stream)
          throws java.io.IOException</pre>
                                <div class="block">Read from an InputStream and process the documents we get</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the InputStream from which to read the data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="read-java.io.File-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>read</h4>
                                <pre>public&nbsp;void&nbsp;read(java.io.File&nbsp;poifsFile)
          throws java.io.IOException</pre>
                                <div class="block">Read from a File and process the documents we get</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>poifsFile</code> - the file from which to read the data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="read-org.apache.poi.poifs.filesystem.POIFSFileSystem-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>read</h4>
                                <pre>public&nbsp;void&nbsp;read(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;poifs)
          throws java.io.IOException</pre>
                                <div class="block">Read from a NPOIFSFileSystem and process the documents we get</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>poifs</code> - the NPOIFSFileSystem from which to read the data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="registerListener-org.apache.poi.poifs.eventfilesystem.POIFSReaderListener-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>registerListener</h4>
                                <pre>public&nbsp;void&nbsp;registerListener(<a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem">POIFSReaderListener</a>&nbsp;listener)</pre>
                                <div class="block">Register a POIFSReaderListener for all documents</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>listener</code> - the listener to be registered</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.NullPointerException</code> - if listener is null</dd>
                                    <dd><code>java.lang.IllegalStateException</code> - if read() has already been
                                        called
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="registerListener-org.apache.poi.poifs.eventfilesystem.POIFSReaderListener-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>registerListener</h4>
                                <pre>public&nbsp;void&nbsp;registerListener(<a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem">POIFSReaderListener</a>&nbsp;listener,
                             java.lang.String&nbsp;name)</pre>
                                <div class="block">Register a POIFSReaderListener for a document in the root
                                    directory
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>listener</code> - the listener to be registered</dd>
                                    <dd><code>name</code> - the document name</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.NullPointerException</code> - if listener is null or name is
                                        null or empty
                                    </dd>
                                    <dd><code>java.lang.IllegalStateException</code> - if read() has already been
                                        called
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="registerListener-org.apache.poi.poifs.eventfilesystem.POIFSReaderListener-org.apache.poi.poifs.filesystem.POIFSDocumentPath-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>registerListener</h4>
                                <pre>public&nbsp;void&nbsp;registerListener(<a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem">POIFSReaderListener</a>&nbsp;listener,
                             <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSDocumentPath.html"
                                title="class in org.apache.poi.poifs.filesystem">POIFSDocumentPath</a>&nbsp;path,
                             java.lang.String&nbsp;name)</pre>
                                <div class="block">Register a POIFSReaderListener for a document in the specified
                                    directory
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>listener</code> - the listener to be registered</dd>
                                    <dd><code>path</code> - the document path; if null, the root directory is
                                        assumed
                                    </dd>
                                    <dd><code>name</code> - the document name</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.NullPointerException</code> - if listener is null or name is
                                        null or empty
                                    </dd>
                                    <dd><code>java.lang.IllegalStateException</code> - if read() has already been
                                        called
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setNotifyEmptyDirectories-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setNotifyEmptyDirectories</h4>
                                <pre>public&nbsp;void&nbsp;setNotifyEmptyDirectories(boolean&nbsp;notifyEmptyDirectories)</pre>
                                <div class="block">Activates the notification of empty directories.<p>
                                    If this flag is activated, the <a
                                        href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderListener.html"
                                        title="interface in org.apache.poi.poifs.eventfilesystem"><code>listener</code></a>
                                    receives
                                    <a href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderEvent.html"
                                       title="class in org.apache.poi.poifs.eventfilesystem"><code>POIFSReaderEvents</code></a>
                                    with nulled <code>name</code> and <code>stream</code></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>notifyEmptyDirectories</code> - if <code>true</code>, empty directories
                                        will be notified
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="main-java.lang.String:A-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>main</h4>
                                <pre>public static&nbsp;void&nbsp;main(java.lang.String[]&nbsp;args)
                 throws java.io.IOException</pre>
                                <div class="block">read in files</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>args</code> - names of the files</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if the files can't be read or have invalid
                                        content
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/POIFSReader.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li>Prev&nbsp;Class</li>
        <li><a href="../../../../../org/apache/poi/poifs/eventfilesystem/POIFSReaderEvent.html"
               title="class in org.apache.poi.poifs.eventfilesystem"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/eventfilesystem/POIFSReader.html" target="_top">Frames</a>
        </li>
        <li><a href="POIFSReader.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
